clear;
clc;
close all;

% Discrete Cosine Transform
x1 = [0 1 2 3 4 5 4 3 2 1]; % Example input (even symmetry：x[n] = x[N-n])
C = DCT(x1);
fprintf('Discrete Cosine Transform (Xc[m], m = 0 ~ floor(N/2)):\n');
disp(C);

% Discrete Cosine Transform： plot
figure(1);
tiledlayout(2,2);
nexttile;
plot(0:length(x1)-1,x1);
title("x[n]");
nexttile;
plot(0:floor(length(x1)/2),x1(1:floor(length(x1)/2)+1));
title("half part of x[n]");
nexttile;
plot(0:length(x1)-1,fft(x1));
title("resulf of DFT");
nexttile;
plot(0:floor(length(x1)/2),C);
title("resulf of DCT");

% Discrete Sine Transform
x2 = [5 4 3 2 1 0 -1 -2 -3 -4]; % Example input (odd symmetry：x[n] = -x[N-n])
S = DST(x2);
fprintf('Discrete Sine Transform (Xs[m], m = 1 ~ floor(N/2)-1):\n');
disp(S);

% Discrete Sine Transform： plot
figure(2);
tiledlayout(2,2);
nexttile;
plot(0:length(x2)-1,x2);
title("x[n]");
nexttile;
plot(1:floor(length(x2)/2)-1,x2(2:floor(length(x2)/2)));
title("half part of x[n]");
nexttile;
plot(0:length(x2)-1,real(1i*fft(x2)));
title("resulf of real(j*DFT)");
nexttile;
plot(1:floor(length(x2)/2)-1,S);
title("resulf of DST");

% Discrete Hartley Transform
x3 = [1 2 3 4]; % Example input (real input)
H = DHT(x3);
fprintf('Discrete Hartley Transform (Xh[m], m = 0 ~ N-1):\n');
disp(H);

% Discrete Hartley Transform： plot
figure(3);
tiledlayout(3,1);
nexttile;
plot(0:length(x3)-1,x3);
title("x[n]");
xticks([0 1 2 3]);
nexttile;
plot(0:length(x3)-1,real(fft(x3))-imag(fft(x3)));
title("resulf of real(DFT)-imag(DFT)");
xticks([0 1 2 3]);
nexttile;
plot(0:length(x3)-1,H);
title("resulf of DHT");
xticks([0 1 2 3]);